MODULE Hashing EXPORTS Main;
IMPORT IO;

TYPE elem = RECORD
	     Status: INTEGER;
	     Value : INTEGER;
	    END;

CONST m = 11;

VAR hashtable : ARRAY[0..m-1] OF elem;

PROCEDURE Locate(x:INTEGER) : INTEGER =
  VAR start, offset, i, k : INTEGER;
  BEGIN
    start  := x MOD m;
    offset := (x MOD 6) + 1;
    i:=0; k:=start;
    WHILE ((i < m) AND (hashtable[k].Value # x) AND (hashtable[k].Status # 0)) DO
      i := i+1;
      k := (start + i*offset) MOD m;
    END;
    RETURN (k);
  END Locate;

PROCEDURE Initialize() =
  BEGIN
    FOR i:= 0 TO m-1 DO
      hashtable[i].Status := 0;
    END;
  END Initialize;

PROCEDURE Search(x:INTEGER) : BOOLEAN =
  VAR i : INTEGER;
  BEGIN
    i := Locate(x);
    IF ((hashtable[i].Value = x) AND (hashtable[i].Status =2)) THEN
      IO.Put("An Stelle "); IO.PutInt(i); IO.Put(" gefunden\n");
    ELSE
      IO.Put("Nicht gefunden!\n");
    END;
    RETURN (hashtable[i].Value =x);
  END Search;

PROCEDURE Delete (x:INTEGER) =
  VAR i:INTEGER;
  BEGIN
    i := Locate(x);
    IF (hashtable[i].Value = x) THEN
      hashtable[i].Status := 1;
      IO.Put("An Stelle "); IO.PutInt(i); IO.Put(" geloescht\n");
    ELSE
      IO.Put("Wert nicht gefunden!\n");
    END;
  END Delete;

PROCEDURE Insert(x:INTEGER) =
  VAR i:INTEGER;
  BEGIN
    i := Locate(x);
    IF (hashtable[i].Status # 2) THEN
      hashtable[i].Status := 2;
      hashtable[i].Value := x;
      IO.Put("An Stelle "); IO.PutInt(i); IO.Put(" eingefuegt\n");
    ELSE
      IF (hashtable[i].Value # x) THEN
        IO.Put("Hashtabelle ist VOLL!\n");
      END;
    END;
  END Insert;


VAR value, command : INTEGER;
    dummy : BOOLEAN;
BEGIN
  Initialize();
  REPEAT
    IO.Put("Auswahl:\n");
    IO.Put("   (1) Einfuegen\n");
    IO.Put("   (2) Loeschen\n");
    IO.Put("   (3) Suchen\n");
    IO.Put("   (0) Beenden\n");
    command := IO.GetInt();

    IF (command>0) AND (command<4) THEN
      IO.Put("Welchen Wert? ");
      value := IO.GetInt();
      CASE command OF
       |1 => Insert(value);
       |2 => Delete(value);
       |3 => dummy:=Search(value);
      END;
    END;
  UNTIL (command = 0);

END Hashing.
