MODULE Heap EXPORTS Main;

IMPORT SIO; (* Importiere Operationen fr Ein-/Ausgabe *)

CONST
  N = 15;  

TYPE FeldTyp = ARRAY [1..N] OF INTEGER;
  
VAR
  f : FeldTyp; 


PROCEDURE initfeld(VAR feld:FeldTyp; n:INTEGER)= 
BEGIN
  FOR i := 1 TO n DO
    feld[i] := ((i*5)+i*i-i DIV 2) MOD 90+10;   (* so eine Art Random *)
  END;
END initfeld;

PROCEDURE DownHeap(VAR field: FeldTyp; n,pos:INTEGER)=
(* field: das Feld, n: Groesse des Feldes, pos: Position des Elements,
   das ein einsortiert werden soll *)
VAR element:INTEGER;   (* speichert das einzusortierende Element *)
    fertig:BOOLEAN;
    max:INTEGER;
BEGIN
  fertig:=FALSE;
  element:=field[pos];
  WHILE (NOT fertig) DO
    (* bestimme das Maximum von A[pos], A[2pos] und A[2pos+1] (falls vorhanden) *) 
    max:=pos;
    IF (2*pos <= n) AND (field[pos] < field[2*pos]) THEN
      max:=2*pos;
    END;
    IF (2*pos+1 <= n) AND (field[max] < field[2*pos+1]) THEN
      max:=2*pos+1;
    END;
    IF max=pos THEN     
    (* element war auf richtiger Position => fertig *)
      fertig:=TRUE;
    ELSE
    (* sonst Elemente vertauschen und weitermachen *) 
        field[pos]:=field[max];
        field[max]:=element;
        pos:=max;                   (* neue Position *)
    END;
  END;
END DownHeap;

PROCEDURE CreateHeap (VAR field: FeldTyp; n:INTEGER)=
(* vom Ende des Feldes alle Werte nach und nach einsortieren
   Start erst bei der Hlfte, da die hintere Hlfte des Feldes
   sofort die Heap-Eigenschaften erfllt *)
BEGIN
  FOR i := 0 TO (n DIV 2-1) DO    
    DownHeap(field,n,n DIV 2-i);
  END;          
END CreateHeap;


(* Ausgabe des Feldes auf dem Bildschirm *)
PROCEDURE ausgabe(VAR field: FeldTyp; n:INTEGER)=
(* stellt das ganze als Baum dar *)
VAR j,k:INTEGER;
BEGIN
  j:=1;k:=256;    (* k=Bildschirmbreite * 2 *)
  FOR i:=1 TO n DO
    BEGIN
      IF i >= j THEN 
        SIO.PutLine(""); 
        j:=j*2;
        k:=k DIV 2;
        FOR l:=1 TO k DIV 2 DO SIO.PutText(" "); END;
      END;
      SIO.PutInt(field[i]);
      FOR l:=1 TO k-2 DO SIO.PutText(" "); END;
    END;
  END;
  SIO.PutLine("");
END ausgabe;

(* Hauptprogramm *)
BEGIN
  initfeld(f,N);
  SIO.PutLine("Vorher:");
  ausgabe(f,N);
  CreateHeap(f,N);
  SIO.PutLine("Nachher:");
  ausgabe(f,N);
END Heap.
